# Author: SirSheepe
# Description: Initializes all of the extra and core mechanics of the game
# Ran: game:start/begin

scoreboard players operation borderShrinkTime game = borderShrinkDuration settings
scoreboard players operation borderShrinkTime game *= tps game

# Border Size
execute if score borderInitialSize settings matches 250 run worldborder set 500
execute if score borderInitialSize settings matches 500 run worldborder set 1000
execute if score borderInitialSize settings matches 750 run worldborder set 1500
execute if score borderInitialSize settings matches 1000 run worldborder set 2000
execute if score borderInitialSize settings matches 1250 run worldborder set 2500
execute if score borderInitialSize settings matches 1500 run worldborder set 3000
execute if score borderInitialSize settings matches 1750 run worldborder set 3500
execute if score borderInitialSize settings matches 2000 run worldborder set 4000

# Grace Period Length
scoreboard players set #calc2 settings 60
scoreboard players operation #calc settings = gracePeriodDuration settings
scoreboard players operation #calc settings /= #calc2 settings

execute if score gracePeriodDuration settings matches 0 run scoreboard players set gracePeriodTime game -1
execute if score gracePeriodDuration settings matches 1.. run scoreboard players operation gracePeriodTime game = gracePeriodDuration settings
execute if score gracePeriodDuration settings matches 1.. run scoreboard players operation gracePeriodTime game *= tps game
execute if score gracePeriodDuration settings matches 1.. run tellraw @a [{"text":"[!] ","color":"yellow"},{"text":"Grace Period will last for ","color":"gray"},{"score":{"name":"#calc","objective":"settings"},"color":"green"},{"text":" minutes","color":"green"}]
execute if score gracePeriodDuration settings matches 0 run tellraw @a [{"text":"[!] ","color":"yellow"},{"text":"There is ","color":"gray"},{"text":"no grace period","color":"red"},{"text":". Be careful!","color":"gray"}]

scoreboard players reset #calc
scoreboard players reset #calc2

execute if score borderInitialSize settings matches 250 at @e[tag=map_centre] run spreadplayers ~ ~ 50 110 true @a[tag=inGame]
execute if score borderInitialSize settings matches 500 at @e[tag=map_centre] run spreadplayers ~ ~ 50 220 true @a[tag=inGame]
execute if score borderInitialSize settings matches 750 at @e[tag=map_centre] run spreadplayers ~ ~ 50 330 true @a[tag=inGame]
execute if score borderInitialSize settings matches 1000 at @e[tag=map_centre] run spreadplayers ~ ~ 50 440 true @a[tag=inGame]
execute if score borderInitialSize settings matches 1250 at @e[tag=map_centre] run spreadplayers ~ ~ 50 550 true @a[tag=inGame]
execute if score borderInitialSize settings matches 1500 at @e[tag=map_centre] run spreadplayers ~ ~ 50 660 true @a[tag=inGame]
execute if score borderInitialSize settings matches 1750 at @e[tag=map_centre] run spreadplayers ~ ~ 50 770 true @a[tag=inGame]
execute if score borderInitialSize settings matches 2000 at @e[tag=map_centre] run spreadplayers ~ ~ 50 880 true @a[tag=inGame]

# Set border shrink delay
scoreboard players operation borderShrinkDelay game = timeUntilShrink settings
scoreboard players operation borderShrinkDelay game *= tps game

# More Mob Drops
execute if score moreMobDropsOption settings matches 1 run tellraw @a [{"text":"[!] ","color":"yellow"},{"text":"All mobs drop more items, and nether mobs always drop a gold ingot.","color":"gray"}]


# Speed Option
execute if score speedOption settings matches 1 run effect give @a[tag=inGame] minecraft:speed 1000000 0 true
execute if score speedOption settings matches 2 run effect give @a[tag=inGame] minecraft:speed 1000000 1 true
execute if score speedOption settings matches 3 run effect give @a[tag=inGame] minecraft:speed 1000000 2 true

# Haste Option
execute if score hasteOption settings matches 1 run effect give @a[tag=inGame] minecraft:haste 1000000 0 true
execute if score hasteOption settings matches 2 run effect give @a[tag=inGame] minecraft:haste 1000000 1 true
execute if score hasteOption settings matches 3 run effect give @a[tag=inGame] minecraft:haste 1000000 2 true

# Jump Boost Option
execute if score jumpBoostOption settings matches 1 run effect give @a[tag=inGame] minecraft:jump_boost 1000000 0 true
execute if score jumpBoostOption settings matches 2 run effect give @a[tag=inGame] minecraft:jump_boost 1000000 1 true
execute if score jumpBoostOption settings matches 3 run effect give @a[tag=inGame] minecraft:jump_boost 1000000 2 true

# Crafting One and Two
execute if score craftingOneOption settings matches 0 run function game:mechanics/remove_crafting_one
execute if score craftingTwoOption settings matches 0 run function game:mechanics/remove_crafting_two

# Expensive Sheilds
execute if score expensiveSheildsOption settings matches 0 run recipe take @a[tag=inGame] expensive_shield:shield
execute if score expensiveSheildsOption settings matches 1 run recipe take @a[tag=inGame] minecraft:shield

# Expensive Sheilds
execute if score friendlyFireOption settings matches 0 run function game:mechanics/friendlyfire_off
execute if score friendlyFireOption settings matches 1 run function game:mechanics/friendlyfire_on

# Health Option
execute if score healthOption settings matches 1 run effect give @a[tag=inGame] minecraft:health_boost 1000000 4 true
execute if score healthOption settings matches 2 run effect give @a[tag=inGame] minecraft:health_boost 1000000 9 true

# Thirst Option
execute if score thirstOption settings matches 1 run give @a[tag=inGame] minecraft:potion{Potion:"minecraft:water"} 1
execute if score thirstOption settings matches 1 run give @a[tag=inGame] written_book{pages:["[\"\",{\"text\":\"-------------------\\n\"},{\"text\":\"Thirst is enabled\",\"bold\":true,\"color\":\"dark_green\"},{\"text\":\"\\n-------------------\\n\",\"color\":\"reset\"},{\"text\":\"This means that you will lose thirst over time and must drink water to refrain from being burdened.\",\"color\":\"black\"},{\"text\":\"\\n\\nAt \",\"color\":\"reset\"},{\"text\":\">70%\",\"bold\":true,\"color\":\"gold\"},{\"text\":\" thirst you will receive slowness, and at lower amounts, bad things will happen.\",\"color\":\"reset\"}]"],title:"About Thirst",author:"Mother Nature",generation:3}
execute if score thirstOption settings matches 1 run scoreboard players set @a[tag=inGame] thirst 0
execute if score thirstOption settings matches 1 run scoreboard players set thirstDelay thirst 200

# Airdrop Option
execute if score airdropOption settings matches 1 run scoreboard players set airdropFrequency game 12000
execute if score airdropOption settings matches 2 run scoreboard players set airdropFrequency game 8400
execute if score airdropOption settings matches 3 run scoreboard players set airdropFrequency game 6000

scoreboard players operation airdropTimer game = airdropFrequency game

# Aquatic Mode Option
execute if score aquaticOption settings matches 1 run effect give @a[tag=inGame] minecraft:conduit_power 1000000 0 true
execute if score aquaticOption settings matches 1 run effect give @a[tag=inGame] minecraft:dolphins_grace 1000000 1 true

execute if score balancedWeaponsOption settings matches 1 run tellraw @a [{"text":"[!] ","color":"yellow"},{"text":"Balanced Weapons is enabled. Hold your tools in your main hand before enchanting, otherwise they will be overriden. This is due to crafting recipe limitations.","color":"gray"}]

execute if score craftingThreeOption settings matches 1 run give @a[tag=inGame] written_book{pages:["[\"\",{\"text\":\"\\n\\n\\n     \"},{\"text\":\"\\u25d1\",\"bold\":true,\"color\":\"light_purple\"},{\"text\":\" Dark Magic \",\"color\":\"reset\"},{\"text\":\"\\u25d0\",\"bold\":true,\"color\":\"light_purple\"},{\"text\":\"\\n         Recipes\\n\\n\\n\",\"color\":\"reset\"},{\"text\":\"  1. \",\"color\":\"gray\"},{\"text\":\"[Apple Modifiers]\",\"color\":\"dark_green\",\"clickEvent\":{\"action\":\"change_page\",\"value\":2},\"hoverEvent\":{\"action\":\"show_text\",\"value\":\"Go to Golden Apple Modifiers\"}},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"  2. \",\"color\":\"gray\"},{\"text\":\"[Traps]\",\"color\":\"dark_green\",\"clickEvent\":{\"action\":\"change_page\",\"value\":5},\"hoverEvent\":{\"action\":\"show_text\",\"value\":\"Go to Player Traps\"}},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"  3. \",\"color\":\"gray\"},{\"text\":\"[Resurrection]\",\"color\":\"dark_green\",\"clickEvent\":{\"action\":\"change_page\",\"value\":9},\"hoverEvent\":{\"action\":\"show_text\",\"value\":\"Go to Resurrection Ritual\"}},{\"text\":\"\\n\\n\",\"color\":\"reset\"},{\"text\":\"   Click a section to\\n       go there\",\"color\":\"dark_gray\"}]","[\"\",{\"text\":\"      Golden Apple\\n        Modifiers\",\"color\":\"gold\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"-------------------\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"By throwing a golden apple and one of these items onto an enchantment table, they can gain additional effects when they are eaten. \",\"color\":\"dark_gray\"},{\"text\":\"\\n\\n\\n       \",\"color\":\"reset\"},{\"text\":\"Recipes -->\",\"color\":\"dark_green\"},{\"text\":\"\\n \",\"color\":\"reset\"}]","[\"\",{\"text\":\"  Speed II (20s): \",\"color\":\"dark_gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"   \\u2022 Sugar (x1)\\n   \\u2022 2 XP Levels\\n  \",\"color\":\"gray\"},{\"text\":\"Strength I (15s):\",\"color\":\"dark_gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"   \\u2022 Blaze Powder (x1)\\n   \\u2022 2 XP Levels\\n  \",\"color\":\"gray\"},{\"text\":\"Absorption II (2m):\",\"color\":\"dark_gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"   \\u2022 Gold Ingot (x1)\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"   \\u2022 2 XP Levels\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"  Resistance (30s):\",\"color\":\"dark_gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"   \\u2022 Iron Bucket (x1)\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"   \\u2022 2 XP Levels\",\"color\":\"gray\"},{\"text\":\"\\n\\n  \",\"color\":\"reset\"},{\"text\":\"More\",\"color\":\"dark_green\"},{\"text\":\" Recipes -->\",\"color\":\"dark_green\"},{\"text\":\"\\n \",\"color\":\"reset\"}]","[\"\",{\"text\":\"  Jump Boost II (20s): \",\"color\":\"dark_gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"   \\u2022 Rabbit Hide (x1)\\n   \\u2022 2 XP Levels\\n  \",\"color\":\"gray\"},{\"text\":\"Night Vision (5m):\",\"color\":\"dark_gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"   \\u2022 Carrot (x1)\\n   \\u2022 2 XP Levels\\n  \",\"color\":\"gray\"},{\"text\":\"Invisibility (30s):\",\"color\":\"dark_gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"   \\u2022 Spider Eye (x1)\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"   \\u2022 2 XP Levels\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"  Fire Resistance (1m):\",\"color\":\"dark_gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"   \\u2022 Lava Bucket (x1)\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"   \\u2022 2 XP Levels\",\"color\":\"gray\"}]","[\"\",{\"text\":\"         Traps\",\"color\":\"red\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"-------------------\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"By throwing the recipe on the ground, it will create a player trap that can only be activated by other teams. Great for making... traps...\",\"color\":\"dark_gray\"},{\"text\":\"\\n\\n\\n       \",\"color\":\"reset\"},{\"text\":\"Recipes -->\",\"color\":\"dark_green\"}]","[\"\",{\"text\":\"Poison Trap\",\"bold\":true,\"color\":\"red\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"Poisons a target for 10 seconds\",\"color\":\"dark_gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"Recipe:\",\"color\":\"dark_green\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\" \\u2022 Diamond (x1)\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\" \\u2022 Fermented Spider Eye (x1)\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"-------------------\",\"color\":\"black\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"Stun Trap\",\"bold\":true,\"color\":\"red\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"Stuns a target for 5 seconds\",\"color\":\"dark_gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"Recipe:\",\"color\":\"dark_green\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\" \\u2022 Diamond (x1)\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\" \\u2022 Snow Block (x1)\",\"color\":\"gray\"}]","[\"\",{\"text\":\"Blindness Trap\",\"bold\":true,\"color\":\"red\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"Blinds a target for 15 seconds\",\"color\":\"dark_gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"Recipe:\",\"color\":\"dark_green\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\" \\u2022 Diamond (x1)\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\" \\u2022 Ink Sac (x1)\",\"color\":\"gray\"},{\"text\":\"\\n-------------------\\n\",\"color\":\"reset\"},{\"text\":\"Fire Trap\",\"bold\":true,\"color\":\"red\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"Sets a target on fire for 2.5 hearts\",\"color\":\"dark_gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"Recipe:\",\"color\":\"dark_green\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\" \\u2022 Diamond (x1)\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\" \\u2022 Flint and Steel (x1)\",\"color\":\"gray\"}]","[\"\",{\"text\":\"Slowness Trap\",\"bold\":true,\"color\":\"red\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"Slows a target for 20 seconds\",\"color\":\"dark_gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"Recipe:\",\"color\":\"dark_green\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\" \\u2022 Diamond (x1)\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\" \\u2022 Soul Sand (x1)\",\"color\":\"gray\"},{\"text\":\"\\n \",\"color\":\"reset\"}]","[\"\",{\"text\":\"     Resurrection\",\"color\":\"dark_purple\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"-------------------\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\"You can bring back a random teammate (or only teammate if a duo) by performing the ritual described next. Make sure they are online before performing it\",\"color\":\"dark_gray\"},{\"text\":\"\\n\\n\\n       \",\"color\":\"reset\"},{\"text\":\"Ritual -->\",\"color\":\"dark_green\"}]","[\"\",{\"text\":\"Crafting a Resurrection Stone can be done by throwing the following items onto an enchantment table:\",\"color\":\"dark_gray\"},{\"text\":\"\\n\\n\\n\",\"color\":\"reset\"},{\"text\":\" \\u2022 Pumpkin Pie (x1)\\n \\u2022 Absorption Golden Apple (x1)\",\"color\":\"gray\"},{\"text\":\"\\n\",\"color\":\"reset\"},{\"text\":\" \\u2022 Emerald (x1)\",\"color\":\"gray\"},{\"text\":\"\\n\\n\",\"color\":\"reset\"},{\"text\":\"       Next -->\",\"color\":\"dark_green\"}]","{\"text\":\"If hostile mobs are turned off, your teammate will spawn ontop of the enchantment table.\\n\\nIf they are on, you must throw it at a skeleton and wait 10 seconds. Your teammate will spawn at the skeleton.\",\"color\":\"dark_gray\"}"],title:"§eDark Magic Lexicon",author:Unknown,generation:3,display:{Lore:["{\"text\":\"Has oblivionis caligine liber \",\"italic\":\"false\",\"color\":\"gray\"}","{\"text\":\"repleti magicae nigrae est recipes\",\"italic\":\"false\",\"color\":\"gray\"}"]}}

scoreboard players set @a game 0
scoreboard players set @a[team=red] game 1
scoreboard players set @a[team=orange] game 2
scoreboard players set @a[team=yellow] game 3
scoreboard players set @a[team=green] game 4
scoreboard players set @a[team=aqua] game 5
scoreboard players set @a[team=blue] game 6
scoreboard players set @a[team=purple] game 7
scoreboard players set @a[team=pink] game 8

weather clear