# Author: SirSheepe
# Description: Runs the systems which must run whilst the game is going on
# Ran: game:main

scoreboard players add gameTick game 1

execute if score gameTick game matches 40.. run bossbar set player_count players @a
execute if score gameTick game matches 40.. unless score endTimer game matches 1.. run function game:loop/main

execute unless score endTimer game matches 1.. if score BorderSize ingame matches 21 unless score borderShrinkTime game matches -1 run function game:start_deathmatch

# Regarding the vertical border, moving at 0.5 blocks / second
execute as @e[tag=border_up] at @s run tp @s ~ ~.0125 ~
execute as @e[tag=border_down] at @s run tp @s ~ ~-.0125 ~
execute at @e[tag=border] run particle flame ~ ~ ~ 5 0 5 0 30 force @a
execute at @e[tag=border_up] positioned ~-20.0 ~-256 ~-20.0 run effect give @a[dx=40,dy=254,dz=40] minecraft:wither 2 0 true
execute at @e[tag=border_down] positioned ~-20.0 ~256 ~-20.0 run effect give @a[dx=40,dy=-254,dz=40] minecraft:wither 2 0 true

execute unless score endTimer game matches 1.. as @a[tag=inGame,scores={deathCount=1..}] at @s run function game:kill_player

execute as @e[tag=gold_head] at @s run particle minecraft:end_rod ~ ~0.1 ~ 0 0 0 0 1

# Game Mechanics
execute unless score endTimer game matches 1.. if score fireworkMissilesOption settings matches 1 as @e[type=firework_rocket,tag=!no_blow] run function game:mechanics/firework_missiles
execute unless score endTimer game matches 1.. if score moreMobDropsOption settings matches 1 run function game:mechanics/more_mob_drops
execute unless score endTimer game matches 1.. if score expensiveSheildsOption settings matches 1 as @a[tag=inGame] if entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:shield",Count:1b}]}] run effect give @s minecraft:slowness 1 0 true
execute unless score endTimer game matches 1.. if score hostileMobsOption settings matches 0 run function game:mechanics/kill_hostile
execute unless score endTimer game matches 1.. if score balancedWeaponsOption settings matches 1 as @a[tag=inGame] run function game:mechanics/better_weapons
execute unless score endTimer game matches 1.. if score instantSmeltOption settings matches 1 as @e[type=minecraft:item] run function game:mechanics/instant_smelt
execute unless score endTimer game matches 1.. if score unstableTntOption settings matches 1 as @a[tag=inGame] at @s run fill ~-5 ~-5 ~-5 ~5 ~5 ~5 tnt[unstable=true] replace tnt[unstable=false]
execute unless score endTimer game matches 1.. if score thirstOption settings matches 1 run function game:mechanics/thirst
execute unless score endTimer game matches 1.. if score silentMobsOption settings matches 1 run function game:mechanics/silent_mobs
execute unless score endTimer game matches 1.. if score harderMobsOption settings matches 1 run function game:mechanics/harder_mobs
execute unless score endTimer game matches 1.. if score airdropOption settings matches 1.. if score gracePeriodTime game matches -1 run function game:mechanics/airdrop
execute unless score endTimer game matches 1.. if score phantomOption settings matches 0 run function game:mechanics/phantom_removal

execute unless score endTimer game matches 1.. unless score gracePeriodTime game matches -1 as @a[tag=inGame] run function game:mechanics/grace_arrow 
execute unless score endTimer game matches 1.. unless score gracePeriodTime game matches -1 as @a[tag=inGame] at @s if entity @a[tag=inGame,distance=0.001..5] run function game:mechanics/grace 
execute unless score endTimer game matches 1.. unless score gracePeriodTime game matches -1 as @a[tag=inGame] at @s unless entity @a[tag=inGame,distance=0.001..5] run effect clear @s minecraft:weakness

execute unless score endTimer game matches 1.. if score craftingThreeOption settings matches 1 run function game:mechanics/black_magic

execute unless score endTimer game matches 1.. as @a[tag=inGame] run function stew:stew_replace

# Check if the game should end

execute if score activeTeams game matches 1 unless score endTimer game matches 1.. run function game:end
execute if score endTimer game matches 1.. as @a[tag=inGame] at @s run particle minecraft:totem_of_undying ~ ~ ~ 0.05 0.05 0.05 0.2 2 normal
execute if score endTimer game matches 1.. run scoreboard players add endTimer game 1

execute if score endTimer game matches 200 run scoreboard players set newMap game 1
execute if score endTimer game matches 200 run scoreboard players set gameReady game 0
execute if score endTimer game matches 200 run scoreboard players set gameState game 0
execute if score endTimer game matches 200 run effect clear @a
execute if score endTimer game matches 200 run clear @a