# Author: SirSheepe
# Description: Handles the selection of the "green team" item in the inventory and all cases of such.
# @s: The player who's inventory we're working in.
# Ran: menu:teams/detect


# Clear all of the team buttons (which will clear them from the players cursor as well).
clear @s minecraft:player_head{TeamItem:1b}


# If the player is on the green team, we will play a sound to notify them.
execute if entity @s[team=green] at @s run playsound minecraft:block.anvil.land master @s ~ ~ ~ 0.5

# If the player is not the green team, we will play a sound and message to notify them.
execute if entity @s[team=!green] at @s run playsound minecraft:block.note_block.harp master @s ~ ~ ~ 0.5 2
tellraw @s[team=!green] ["",{"text":"[!] ","color":"yellow"},{"text":"You've joined the ","color":"gray"},{"text":"Green ","color":"green"},{"text":"team.","color":"gray"}]

# The player isn't on this team, so let's add them!
execute if entity @s[team=!green] run team join green @s


# Now we fix the inventory
function menu:teams/unselect_all
function menu:teams/select_team