# Author: SirSheepe
# Description: Handles the selection of the "spectator team" item in the inventory and all cases of such.
# @s: The player who's inventory we're working in.
# Ran: menu:teams/detect


# Clear all of the team buttons (which will clear them from the players cursor as well).
clear @s minecraft:player_head{TeamItem:1b}

tag @s[team=] add q
tag @s[team=patreon] add q
tag @s[team=vertex] add q

# If the player is on the spectator team, we will play a sound to notify them.
execute if entity @s[tag=q] at @s run playsound minecraft:block.anvil.land master @s ~ ~ ~ 0.5

# If the player is not the spectator team, we will play a sound and message to notify them.
execute unless entity @s[tag=q] at @s run playsound minecraft:block.note_block.harp master @s ~ ~ ~ 0.5 2
execute unless entity @s[tag=q] run tellraw @s ["",{"text":"[!] ","color":"yellow"},{"text":"You're now a ","color":"gray"},{"text":"Spectator","color":"white"},{"text":".","color":"gray"}]

# The player isn't on this team, so let's add them!
execute unless entity @s[tag=q] run team leave @s

function lobby:sign_vertex
function lobby:sign_patreon

tag @s remove q

# Now we fix the inventory
function menu:teams/unselect_all
function menu:teams/select_team